/* 
   Copyright 1994-2003 Free Software Foundation, Inc.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
   USA

   You may contact the author at:

   mailto::camille@bluegrass.net

   or by snail mail at:

   David Lindauer
   850 Washburn Ave Apt 99
   Louisville, KY 40222
*/
#include <stdio.h>
#include <errno.h>
#include <string.h>

static char *thunk(const char *string, int error)
{
   static char strbuf[256] ;
   char *str ;
   if (error >= _sys_nerr)
      str = "Unknown error" ;
   else
      str = _sys_errlist[error] ;
   strbuf[0] = 0 ;
   if (string && *string) {
      strcat(strbuf,string) ;
      strcat(strbuf,": ") ;
   }
   strcat(strbuf,str) ;
   strcat(strbuf,"\n") ;
   return strbuf ;
}
char *_RTL_FUNC strerror(int error)
{
   return thunk(0,error) ;
}
char *_RTL_FUNC _strerror(const char *str)
{
   return thunk(str,errno) ;
}